![freeCodeCamp.org 社区横幅](https://s3.amazonaws.com/freecodecamp/wide-social-banner.png)
[![构建状态](https://travis-ci.org/freeCodeCamp/freeCodeCamp.svg?branch=staging)](https://travis-ci.org/freeCodeCamp/freeCodeCamp)
[![欢迎 Pull Requests](https://img.shields.io/badge/PRs-welcome-brightgreen.svg?style=flat)](http://makeapullrequest.com)
[![first-timers-only 友好](https://img.shields.io/badge/first--timers--only-friendly-blue.svg)](http://www.firsttimersonly.com/)
[![了解弱点](https://snyk.io/test/github/freecodecamp/freecodecamp/badge.svg)](https://snyk.io/test/github/freecodecamp/freecodecamp)


## 欢迎来到freeCodeCamp.org的开源代码库和课程！

[freeCodeCamp.org](https://www.freecodecamp.org) 是一个友好的社区，在这里可以免费学习编程。 社区由[捐助者支持的501(c)(3)非营利组织](https://donate.freecodecamp.org)运营，目标是为了帮助成千上万忙碌的成人实现技术转型。目前为止，我们已经帮助了超过10,000人得到了他们的第一份开发工作。

我们的互联网全栈开发课程是完全免费和自主的，此外我们还有数以千计的互动编程挑战来帮助你扩展你的技能。

## 内容列表

* [技能认证证书](#技能认证证书)
* [学习平台](#学习平台)
* [发现了一个异常](#发现了一个异常)
* [发现了一个安全问题](#发现了一个安全问题)
* [参与贡献](#参与贡献)
* [开源许可](#开源许可)

### 技能认证证书

freeCodeCamp.org提供了一些免费的开发技能认证证书。每个证书需要构建5个必须的互联网应用工程，同时我们提供了数以百计可选的编程挑战来帮助你为构建这些工程做准备。我们估计对于编程初学者来说每个证书将会花费300个小时的投入来获取。

在freeCodeCamp.org课程中的30个工程，每一个都有自己的敏捷用户故事和自动化测试。这可以帮助你渐进地构建你的工程，并且确保你在提交之前完成了所有的用户故事。

你可以通过[freeCodeCamp's CDN](https://cdn.freecodecamp.org/testable-projects-fcc/v1/bundle.js)获取到这些测试合集。这意味着你可以在CodePen和Glitch（或者甚至是在你本地的计算机环境）上构建这些工程。

一旦你取得了一个证书，你将一直拥有它。你可以一直把它链接到领英或者résumé上。并且当你期望的雇主或者自由职业雇主点击链接时，他们可以一个看到一个针对你的认证证书。

唯一例外的是如果我们发现有违反我们[学术诚信政策](https://www.freecodecamp.org/academic-honesty)的情况。当我们抓到有人明确地剽窃（未标引用地提交他人的代码或者工程作为他自己的），我们将会做所有严格的教育机构会做的事情——我们会取消他的认证证书并且禁掉他。

这里是我们的六个核心证书：

#### 1. 响应式Web设计证书

- 基础HTML和HTML5
- 基础CSS
- 应用可视化设计
- 应用可访问性
- 可视化Web设计原则
- CSS Flexbox
- CSS Grid <br />
  <br />
  **工程**: 悼文页, 调查表单, 产品登陆页, 技术文档页, 个人作品集网站页

#### 2. JavaScript算法与数据结构证书

- 基础JavaScript
- ES6
- 正则表达式
- 调试
- 基础数据结构
- 算法脚本
- 面向对象编程
- 函数式编程 <br />
  <br />
  **工程**: 回文检查器, 罗马数字转换器, 凯撒加密, 电话号码验证, 收银机

#### 3. 前端库证书

- Bootstrap
- jQuery
- Sass
- React
- Redux
- React与Redux <br />
  <br />
  **工程**: 随机引文器, Markdown预览器, 击鼓器, JavaScript计算器, 波莫多罗钟（番茄时钟）

#### 4. 数据可视化证书

- 使用D3数据可视化
- JSON接口和Ajax <br />
  <br />
  **工程**: 条形图, 散点图, 热力图, 等值线图, 树状图

#### 5. 接口和微服务证书

- 使用Npm管理包依赖
- 基础Node和Express
- MongoDB和Mongoose <br />
  <br />
  **工程**: 时间戳微服务, 请求头解析器, 网址缩短器, 训练跟踪器, 文件元数据微服务

#### 6. 信息安全与质量保证证书

- 使用HelmetJS保障信息安全
- 质量保证和使用Chai进行测试
- 高级Node和Express <br />
  <br />
  **工程**: 米制-英制度量转换器, 问题跟踪器, 个人库, 股票价格检查器, 匿名信息板

#### 全栈开发证书

一旦你取得了所有的这6个证书，你就可以认领属于你的freeCodeCamp.org全栈开发证书了。这最后的荣誉意味着，你使用大范围的Web开发工具完全地完成了约1,800个小时的编程。

#### 遗留证书

同时我们还有3个从2015年的课程中遗留的证书，这些证书现在仍然是有效的。所有这些遗留证书所需要的工程会在freeCodeCamp.org保持可访问状态。

- 遗留前端开发证书
- 遗留数据可视化证书
- 遗留后端开发证书

### 学习平台

这些代码真实运行在[freeCodeCamp.org](https://www.freecodecamp.org)上。

同时我们社区还有：

- 一个[论坛](https://www.freecodecamp.org/forum)，在这里你可以经常获取编程帮助或者在几小时内得到工程反馈。
- 一个[YouTube频道](https://youtube.com/freecodecamp)，在这里有免费的课程，有关Python、SQL、Android和其他各种各样的技术。
- 遍布全球的[线下学习社团](https://study-group-directory.freecodecamp.org/)，在这里你可以和志同道合的人一起编程。
- 一个综合的[数以千计的编程话题向导](https://guide.freecodecamp.org/)。
- 在Medium上[大量的技术文章发表](https://medium.freecodecamp.org)。
- 一个[Facebook社团](https://www.facebook.com/groups/freeCodeCampEarth/permalink/428140994253892/)，全球范围内拥有超过100,000个成员。

### [点击这里加入我们的社区](https://www.freecodecamp.org/signin)。

### 发现了一个异常？

如果你认为你发现了一个异常， 首先请阅读[关于我发现了一个异常的帮助](https://www.freecodecamp.org/forum/t/how-to-report-a-bug/19543)文章并且循序其中的指示。如果你确信这是一个新的异常，并且确认其他人页遇到了一样的问题，请继续创建一个新的GitHub Issue。并且确保包含了足够多的信息以方便我们能重现这个异常。

### 发现了一个安全问题？

请不要在GitHub上为安全问题创建Issues。作为替代，请发送一个E-mail到`security@freecodecamp.org`，我们会紧接地对此进行调查。

### 参与贡献

#### [请遵循这个步骤参与贡献。](/docs/chinese/CONTRIBUTING.md)

### 开源许可

这个库的内容受到以下开源许可的约束：

- 电脑软件接受[BSD-3-Clause](LICENSE.md)开源许可。
- 在[`/curriculum`](/curriculum)目录下的所有[课程内容](https://www.npmjs.com/package/@freecodecamp/curriculum)接受[CC-BY-SA-4.0](/curriculum/LICENSE.md)开源许可。
