![freeCodeCamp.org Social Banner](https://s3.amazonaws.com/freecodecamp/wide-social-banner.png)
[![Build Status](https://travis-ci.org/freeCodeCamp/freeCodeCamp.svg?branch=staging)](https://travis-ci.org/freeCodeCamp/freeCodeCamp)
[![Pull Requests Welcome](https://img.shields.io/badge/PRs-welcome-brightgreen.svg?style=flat)](http://makeapullrequest.com)
[![first-timers-only Friendly](https://img.shields.io/badge/first--timers--only-friendly-blue.svg)](http://www.firsttimersonly.com/)
[![Known Vulnerabilities](https://snyk.io/test/github/freecodecamp/freecodecamp/badge.svg)](https://snyk.io/test/github/freecodecamp/freecodecamp)


## Benvenuti nel programma di studio del codice open source di freeCodeCamp.org!

freeCodeCamp.org è una comunità amichevole dove puoi imparare a programmare gratuitamente. È gestito da una [non profit finanziata dal donatore 501(c)(3)](https://donate.freecodecamp.org) con lo scopo di aiutare milioni di adulti impegnati a passare alla tecnologia. La nostra comunità ha già aiutato più di 10.000 persone a ottenere il loro primo incarico di sviluppatore.

Il nostro curriculum stack completo di sviluppo web è completamente gratuito e autonomo. Abbiamo migliaia di sfide di codifica interattive per aiutarti ad espandere le tue capacità.

## Sommario

* [Certificazioni](#certifications)
* [La Piattaforma di apprendimento](#the-learning-platform)
* [Trovato un bug/errore di codice](#found-a-bug)
* [Trovato un problema di sicurezza](#found-a-security-issue)
* [Come Contribuire](#contributing)
* [Licenza](#license)

### Certificazioni

freeCodeCamp.org offre diverse certificazioni gratuite per gli sviluppatori. Ciascuna di queste certificazioni prevede la realizzazione di 5 progetti di Web app, insieme a centinaia di sfide di codifica opzionali per aiutarti a prepararti per tali progetti. Estimiamo che ogni certificazione richiederà a un programmatore principiante circa 300 ore per guadagnarle.

Ognuno di questi 30 progetti nel curriculum di FreeCodeCamp.org ha le proprie richieste da tenere in conto quando costruire il progetto e test automatizzati. Questi ti aiutano a sviluppare il tuo progetto in modo incrementale e assicurarti di aver soddisfatto tutte le richieste prima di inviarlo.

È possibile inserire queste suite di test attraverso [CDC di FreeCodeCamp](https://cdn.freecodecamp.org/testable-projects-fcc/v1/bundle.js). Ciò significa che puoi creare questi progetti su siti Web come CodePen e Glitch o persino sull'ambiente di sviluppo del tuo computer locale.

Una volta ottenuto un certificato, lo avrai per sempre. Sarai sempre in grado di collegarti ad esso dal tuo LinkedIn o curriculum. E quando i tuoi potenziali datori di lavoro o clienti freelance cliccano su quel link, vedranno una certificazione verificata specifica per te.

L'unica eccezione a questo è nel caso in cui scopriamo violazioni della nostra [Politica sull'Onestà Accademica](https://www.freecodecamp.org/academic-honesty). Quando catturiamo le persone plagiando in modo inequivocabile (sottomettendo il codice o i progetti di altre persone come loro senza citazione), facciamo ciò che dovrebbero fare tutte le rigorose istituzioni di apprendimento - revociamo le loro certificazioni e bandiamo/proibiamo quelle persone.

Ecco le nostre sei certificazioni di base:

#### 1. Certificazione di Responsive Web Design

- HTML di base e HTML5
- CSS di base
- Design Visual Applicato
- Accessibilità applicata
- Principi di Responsive Web Design
- CSS Flexbox
- Griglia CSS <br />
  <br />
  **Progetti**: La Pagina tributo, Il Modulo di indagine, La Pagina di destinazione del prodotto, La Pagina di documentazione tecnica, La Pagina web del portafoglio personale

#### 2. Certificazione di algoritmi JavaScript e strutture di dati 

- JavaScript di base
- ES6
- Espressioni regolari
- Debugging
- Strutture dati di base
- Scripting dell'algoritmo
- Programmazione orientata agli oggetti
- Programmazione funzionale <br />
  <br />
  **Progetti**: Il Correttore di Palindrome, Convertitore dei numeri romani, La cifra di Cesare, Il validatore di numero telefonico, Il registratore di cassa

#### 3. Certificazione di Librerie Front End

- Bootstrap
- jQuery
- Sass
- React
- Redux
- React and Redux <br />
  <br />
  **Progetti**: La Macchina di quote casuali, Il Visualizzatore di Markdown, La macchinetta Drum, La Calcolatrice JavaScript, L'orologio Pomodoro

#### 4. Certificazione visualizzazione dei dati

- Visualizzazione dei dati con D3
- API JSON e Ajax <br />
  <br />
  **Progetti**: Il Grafico a barre, Il Grafico a dispersione, La Mappa di calore, Mappa di coropleta, Diagramma della Mappa ad albero
  
#### 5. Certificazione API e Microservizi

- Gestione dei pacchetti con Npm
- Node di base ed Express
- MongoDB e Mongoose <br />
  <br />
  **Progetti**: Il Microservizio Data e ora, Il Parser di richiesta dell'intestazione, L'accorciatore dell'URL, Il tracker/tracciatore dell'esercizio, I file di Metadata del Microservizio

#### 6. Certificazione della sicurezza delle informazioni e della garanzia della qualità

- Sicurezza delle informazioni con HelmetJS
- Garanzia di qualità e test con Chai
- Node avanzato ed Express <br />
  <br />
  **Progetti**: Il convertitore metrico-imperiale, Il tracker/tracciatore dei problemi, La biblioteca personale, Il controllo prezzi delle azioni, Il forum dei messaggi anonimi

#### Certificazione per lo sviluppo di Stack completo (Full Stack Development)

Una volta che avrai ottenuto tutte queste 6 certificazioni, potrai richiedere la certificazione di sviluppo completo dello stack/Full Stack Development FreeCodeCamp.org. Questa distinzione finale significa che hai completato circa 1.800 ore di codifica con una vasta gamma di strumenti di sviluppo web.

#### Certificazioni di Legacy

Abbiamo anche 3 certificazioni di legacy dal nostro curriculum nel 2015, che sono ancora disponibili. Tutti i progetti richiesti per queste certificazioni di legacy rimarranno disponibili su freeCodeCamp.org.

- Certificazione di legacy dello sviluppo front end  (Legacy Front End Development)
- Certificazione di legacy della visualizzazione dei dati (Legacy Data Visualization Certification)
- Certificazione di legacy del back end (Legacy Back End Development Certification)

### La piattaforma di apprendimento

Questo codice è in esecuzione in diretta su [freeCodeCamp.org](https://www.freecodecamp.org).

La nostra comunità ha tra l'altro:

- Un [forum](https://www.freecodecamp.org/forum) molto attivo
- Migliaia di [gruppi di studio locali](https://study-group-directory.freecodecamp.org/) in tutto il mondo, dove è possibile programmare insieme di persona
- Una pubblicazione di [Developer News](https://www.freecodecamp.org/news), un sito gratuito, open source e senza pubblicità per il cross-post degli articoli del tuo blog.
- Un popolare [canale YouTube](https://youtube.com/freecodecamp)
- Una guida completa [di migliaia di argomenti di programmazione](https://guide.freecodecamp.org/)

### [Unisciti alla nostra community qui](https://www.freecodecamp.org/signin).

### Trovato un bug/errore di codice?

Se pensi di aver trovato un bug/errore di codice, leggi prima l'articolo [Aiuto ho trovato un bug/errore di codice](https://www.freecodecamp.org/forum/t/how-to-report-a-bug/19543) e segui le sue istruzioni. Se sei sicuro che sia un nuovo bug/errore di codice e hai confermato che qualcun altro si trova di fronte allo stesso problema, procedi e crea un nuovo problema con GitHub. Assicurati di includere quante più informazioni possibili in modo che possiamo riprodurre il bug/errore di codice.

### Trovato un problema di sicurezza?

Si prega di non creare problemi GitHub per i problemi di sicurezza. Invece, si prega di inviare una mail a `security@freecodecamp.org` e lo esamineremo immediatamente.

### Come Contribuire

#### [Per favore segui questi passaggi per contribuire.](CONTRIBUTING.md)

### Licenza

Copyright © 2018 freeCodeCamp.org

Il contenuto di questa repository è vincolato dalle seguenti licenze:

- Il software del computer è concesso in licenza con la licenza [BSD-3-Clause](LICENSE.md).
- Il [contenuto curriculare](https://www.npmjs.com/package/@freecodecamp/curriculum) nella cartella [`/curriculum`](/curriculum) e le sue sottodirectory sono concessi in licenza [CC-BY-SA-4.0](/curriculum/LICENSE.md).
