<!-- do not translate this -->
| [Read these guidelines in other languages](/docs/i18n-languages) |
|-|
<!-- do not translate this -->

# Pautas de Contribución

¡Hola 👋!

freeCodeCamp.org es posible gracias a miles de voluntarios amables como tú. Estamos muy agradecidos por tus contribuciones y nos complace darte la bienvenida a bordo.

Cumplimos estrictamente nuestro ["Código de conducta"](https://www.freecodecamp.org/code-of-conduct). Tómate un momento para leerlo. Sólo son 196 palabras.

¡Feliz contribución 🎉!

## Aquí hay algunas maneras divertidas en las que puedes ayudar:

Puedes optar por contribuir a cualquier área de tu interés:

1. [Contribuir a esta base de código fuente abierto.](#contribuye-a-esta-base-de-código-abierto)

    Ayúdanos a crear o editar [artículos de guía](https://www.freecodecamp.org/guide), [desafíos de codificación](https://www.freecodecamp.org/learn) o a corregir errores en la plataforma de aprendizaje.

2. Ayuda a los campistas en nuestro [foro público](https://www.freecodecamp.org/forum/):

    - ❓ [Respondiendo a sus preguntas](https://www.freecodecamp.org/forum/?max_posts=1).
    - 💬 [Aportando comentarios a sus proyectos](https://www.freecodecamp.org/forum/c/project-feedback?max_posts=1).

3. Ayúdanos a agregar subtítulos en nuestro [canal de YouTube](https://www.youtube.com/channel/UC8butISFwT-Wl7EV0hUK0BQ/videos).

## Contribuye a esta base de código abierto

Tenemos una gran base de código abierto con miles de [Desafíos de Codificación](https://www.freecodecamp.org/learn) y otras fuentes de codigo para fortalecer nuestra plataforma de aprendizaje.

Puedes ayudarnos a:

- [📝 Investigar, escribir y actualizar nuestras guías.](#investiga-escribe-y-actualiza-nuestras-guías)

- [💻 Crear, actualizar y corregir errores en nuestros desafíos de código.](#crear-actualizar-y-corregir-errores-en-nuestros-desafíos-de-codificación)

- [🌐 Traducir artículos de guía y desafíos de código.](#traducir-artículos-de-guía-y-desafíos-de-codificación)

- [🛠 Corregir errores en la plataforma de aprendizaje de freeCodeCamp.org.](#investiga-escribe-y-actualiza-nuestras-guías)

### Investiga, escribe y actualiza nuestras guías

**¿Qué son los artículos de guía?**

Los artículos de guía te ayudan a comprender rápidamente un concepto de tecnología. Son explicaciones breves y sencillas que puedes leer antes de ir a recursos más profundos.

Puedes encontrar un [artículo de ejemplo sobre elementos HTML aquí](./client/src/pages/html/elements/index.md).

**¿Sobre qué puedo escribir un artículo?**

Agradecemos tu ayuda al escribir estos artículos. No tienes que ser un experto en un tema para escribir sobre él; toda esta guía es de código abierto, por lo que incluso si cometes un error, otro colaborador lo corregirá.

Para obtener ayuda, busca un `esbozo` de cualquier artículo en nuestra [guía](https://www.freecodecamp.org/guide), escribe el artículo y luego abre una solicitud para reemplazar el esbozo con tu artículo. Una solicitud o [pull request](https://help.github.com/articles/about-pull-requests/) es la forma en que sugerirán los cambios. Permite a otros conocer tus cambios, revisarlos y adóptarlos.

Si no puedes encontrar un esbozo sobre el tema que deseas escribir, puedes abrir un PR (pull request) que crea el esbozo e incluye tu borrador del artículo.

**Si deseas trabajar en ello, sigue estas pautas:**

#### [cómo trabajar en los artículos de guía.](/docs/how-to-work-on-guide-articles.md)

### Crear, actualizar y corregir errores en nuestros desafíos de codificación

Todos nuestros desafíos de codificación son curados por la comunidad, aportando conocimiento experto de voluntarios como tú.

Puedes ayudar a expandirlos y hacer que su redacción sea más clara. Puedes actualizar las historias de usuario para explicar mejor el concepto e incluso eliminar las redundantes. También puedes mejorar las pruebas para que sean más precisas al valorar el código de los usuarios.

**Si deseas trabajar en ello, sigue estas pautas:**

#### [cómo trabajar en desafíos de codificación.](/docs/how-to-work-on-coding-challenges.md)

### Traducir artículos de guía y desafíos de codificación

Puedes ayudarnos a traducir nuestros artículos de Guía y desafíos de código para un idioma que hables. Actualmente tenemos versiones traducidas en:

- [Chino (中文)](https://github.com/freeCodeCamp/freeCodeCamp/tree/master/curriculum/challenges/chinese)
- [Ruso (русский)](https://github.com/freeCodeCamp/freeCodeCamp/tree/master/curriculum/challenges/russian)
- [Árabe (عربى)](https://github.com/freeCodeCamp/freeCodeCamp/tree/master/curriculum/challenges/arabic)
- [Español](https://github.com/freeCodeCamp/freeCodeCamp/tree/master/curriculum/challenges/spanish)
- [Português](https://github.com/freeCodeCamp/freeCodeCamp/tree/master/curriculum/challenges/portuguese)

Nos encantaría tu ayuda para mejorar la calidad de estas traducciones. Millones de personas usan la versión en inglés de freeCodeCamp.org, y esperamos que millones más también usen estas versiones traducidas.

### Ayúdanos a corregir errores en la plataforma de aprendizaje de freeCodeCamp.org

Nuestra plataforma de aprendizaje se ejecuta en una moderna pila de JavaScript. Tiene varios componentes, herramientas y bibliotecas, que incluyen pero no se limitan a Node.js, MongoDB, LoopBack, OAuth 2.0, React, Gatsby, Webpack y más.

En general,

- Tenemos un servidor de API basado en Node.js.
- Un conjunto de aplicaciones cliente basadas en React.
- Un script que usamos para evaluar nuestros proyectos Frontend.

Contribuir a esto requiere cierta comprensión de las API, la sintaxis de ES6 y mucha curiosidad.

Esencialmente, esperamos cierta familiaridad básica con algunas de las tecnologías, herramientas y librerías mencionadas anteriormente. Dicho esto, no es necesario que seas un experto en ello.

Siéntete libre de hacernos preguntas, en los hilos relacionados con problemas, y estaremos encantados de aclarar. En caso de duda, puede comunicarse con Mrugesh Mohapatra [`@raisedadead`](https://github.com/raisedadead) o Stuart Taylor[`@bouncey`](https://github.com/bouncey) de nuestro equipo de desarrollo de la plataforma para ayudarte con esto.

Si deseas trabajar en mejorar nuestra base de código, aqui tienes [cómo configurar freeCodeCamp localmente.](/docs/how-to-setup-freecodecamp-locally.md)

## Preguntas frecuentes

**¿Cómo puedo reportar un error, que no está publicado?**

Si crees que has encontrado un error, primero lee el artículo ["Ayuda, he encontrado un error"](https://forum.freecodecamp.org/t/how-to-report-a-bug/19543) y sigue las instrucciones.

Si estás seguro de que es un error nuevo, siga adelante y crea un nuevo problema o Issue en GitHub. Asegúrate de incluir la mayor cantidad de información posible para que podamos reproducir el error. Tenemos una plantilla de problemas predefinida para ayudarte a documentar esto.

Ten en cuenta que cualquier problema que se registre para resolver dudas sobre la codificación de un desafío se cerrará. El rastreador de problemas es estrictamente para los temas y discusiones relacionados con el código base. Deberías [buscar ayuda en el foro](https://www.freecodecamp.org/forum) antes de reportar un problema en caso de duda.
**¿Cómo puedo reportar un problema de seguridad?**

Por favor, no crees Issues de GitHub para problemas de seguridad. En su lugar, envía un correo electrónico a `security@freecodecamp.org` y lo veremos de inmediato.

**Estoy atascado en algo que no está en esta documentación. ¿Cómo puedo obtener ayuda?**

No dudes en pedir ayuda en:

- [La categoría "Colaboradores" en nuestro foro público](https://www.freecodecamp.org/forum/c/contributors).
- [La sala de chat de nuestros colaboradores públicos en Gitter](https://gitter.im/FreeCodeCamp/Contributors).

Nos emociona ayudarte a contribuir con cualquiera de los temas en los que te gustaría trabajar. Asegúrate de buscar tu consulta antes de publicar una nueva. Sé educado y paciente. Nuestros voluntarios y moderadores de la comunidad están siempre alrededor para guiarte a través de tus consultas.

**Soy nuevo en GitHub y Open Source en general:**

Lee nuestra [Guía de cómo contribuir al código abierto](https://github.com/freeCodeCamp/how-to-contribute-to-open-source/blob/master/README-ES.md).

**¿Qué significan las diferentes etiquetas, que aparecen en los problemas?**

Los moderadores de nuestra comunidad [evalúan](https://en.wikipedia.org/wiki/Software_bug#Bug_management) problemas y solicitudes y los etiquetan según la prioridad, la gravedad y otros factores. Puedes [encontrar un glosario completo de sus significados aquí](https://github.com/freecodecamp/freecodecamp/labels).

Debes revisar los problemas **`Help Wanted`** o **`first timers welcome`** para una búsqueda rápida de lo que está disponible para que trabajes. Estos están libres para todos y no necesita permisos antes de trabajar en ellos.

Si estos temas carecen de claridad sobre lo que debe hacerse, no dudes en hacer preguntas en los comentarios.

**Encontré un error tipográfico, ¿debo reportar de un problema antes de poder hacer un pull request?**

Para los errores tipográficos y otros cambios de redacción, puedes abrir directamente los pull request sin crear primero issues. Los issues son más bien para discutir problemas más grandes asociados con el código, o aspectos más estructurales del currículo.
